Index: metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/ApplicationController.java
===================================================================
--- metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/ApplicationController.java	(revision 7587)
+++ metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/ApplicationController.java	(revision 7588)
@@ -31,7 +31,6 @@
 import org.apache.commons.logging.Log;
 import org.apache.commons.logging.LogFactory;
 import org.springframework.context.ApplicationContext;
-import org.springframework.context.support.ClassPathXmlApplicationContext;
 import org.springframework.context.support.FileSystemXmlApplicationContext;
 
 /**
@@ -90,8 +89,6 @@
         return context;
     }
 
-  
-    
     /**
      * Get the path of the Spring configuration file.
      * @return the path of the Spring configuration file.
Index: metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/MetacatIndexServlet.java
===================================================================
--- metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/MetacatIndexServlet.java	(revision 7587)
+++ metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/MetacatIndexServlet.java	(revision 7588)
@@ -52,8 +52,8 @@
  */
 public class MetacatIndexServlet extends HttpServlet {
     
-    //Use the file prefix to indicate this is a absolute path.
-    // seet http://www.docjar.com/docs/api/org/springframework/context/support/FileSystemXmlApplicationContext.html
+    // Use the file prefix to indicate this is a absolute path.
+    // see http://www.docjar.com/docs/api/org/springframework/context/support/FileSystemXmlApplicationContext.html
     private static final String FILEPREFIX = "file:";
     
 	private static Log log = LogFactory.getLog(MetacatIndexServlet.class);
@@ -64,9 +64,29 @@
     public void init(ServletConfig config) throws ServletException {
         //System.out.println("++++++++++++++++++++++++------------------- start the servlet");
     	
-    	// load the metacat.prioerties into D1 Settings utility
-    	// this gives us access to all metacat properties as well as 
-    	// overriding the d1 properties as needed
+    	initializeSharedConfiguration(config);
+		
+    	// initialize the application using the configured application-context
+        URL url = getClass().getResource("/index-processor-context.xml");
+        //System.out.println("the url is "+url);
+        //System.out.println("the path is "+url.getPath());
+        //System.out.println("the file is "+url.getPath());
+        ApplicationController controller = new ApplicationController(FILEPREFIX + url.getFile());
+        List<SolrIndex> list = controller.getSolrIndexes();
+        //System.out.println("++++++++++++++++++++++++------------------- the size is  "+list.size());
+    }
+    
+    /**
+     * Loads the metacat.prioerties into D1 Settings utility
+     * this gives us access to all metacat properties as well as 
+     * overriding any properties as needed.
+     * 
+     * Makes sure shared Hazelcast configuration file location is set
+     * 
+     * @param config the servlet config
+     */
+    private void initializeSharedConfiguration(ServletConfig config) {
+    	
 		try {
 			// find the sibling metacat.properties file
 			String metacatPropertiesFilePath = config.getServletContext().getInitParameter("metacat.properties.path");
@@ -76,7 +96,8 @@
 		} catch (ConfigurationException e) {
 			log.error("Could not initialize shared Metacat properties. " + e.getMessage(), e);
 		}
-		// make sure hazelcast configuration is defined
+		
+		// make sure hazelcast configuration is defined so that
 		String hzConfigFileName = Settings.getConfiguration().getString("dataone.hazelcast.configFilePath");
 		if (hzConfigFileName == null) {
 			// use default metacat hazelcast.xml file in metacat deployment
@@ -88,14 +109,6 @@
 			// set it for other parts of the code
 			Settings.getConfiguration().setProperty("dataone.hazelcast.configFilePath", hzConfigFileName);
 		}
-		
-        URL url = getClass().getResource("/index-processor-context.xml");
-        //System.out.println("the url is "+url);
-        //System.out.println("the path is "+url.getPath());
-        //System.out.println("the file is "+url.getPath());
-        ApplicationController controller = new ApplicationController(FILEPREFIX+url.getFile());
-        List<SolrIndex> list = controller.getSolrIndexes();
-        //System.out.println("++++++++++++++++++++++++------------------- the size is  "+list.size());
     }
     
     /**