Index: metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/SolrServerFactory.java
===================================================================
--- metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/SolrServerFactory.java	(revision 7629)
+++ metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/SolrServerFactory.java	(nonexistent)
@@ -1,100 +0,0 @@
-/**
- *  '$RCSfile$'
- *    Purpose: A class that gets Accession Number, check for uniqueness
- *             and register it into db
- *  Copyright: 2000 Regents of the University of California and the
- *             National Center for Ecological Analysis and Synthesis
- *    Authors: Jivka Bojilova, Matt Jones
- *
- *   '$Author$'
- *     '$Date$'
- * '$Revision$'
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
- */
-package edu.ucsb.nceas.metacat.index;
-
-import java.io.File;
-
-import org.apache.commons.logging.Log;
-import org.apache.commons.logging.LogFactory;
-import org.apache.solr.client.solrj.SolrServer;
-import org.apache.solr.client.solrj.embedded.EmbeddedSolrServer;
-import org.apache.solr.client.solrj.impl.CommonsHttpSolrServer;
-import org.apache.solr.core.CoreContainer;
-import org.dataone.configuration.Settings;
-
-/**
- * A factory for creating SolrServer implementations based on
- * configuration in Settings.java
- * Options are as follows.
- * 
- * Embedded (default):
- * solr.server.classname=org.apache.solr.client.solrj.embedded.EmbeddedSolrServer
- * solr.homeDir=/path/to/solr/home
- * 
- * HTTP:
- * solr.server.classname=org.apache.solr.client.solrj.impl.CommonsHttpSolrServer
- * solr.endpoint=http://endpoint/to/solr/service
- * 
- * @author leinfelder + tao
- *
- */
-public class SolrServerFactory {
-	
-    public static final String SOLR_HOME_PROPERTY_NAME = "solr.homeDir";
-    public static final String SOLR_CONFIG_FILE_NAME_PROPERTY_NAME = "solr.configFileName";
-    public static final String SOLR_COLLECTION_NAME_PROPERTY_NAME = "solr.collectionName";
-    public static final String SOLR_SERVER_CLASSNAME_PROPERTY_NAME = "solr.server.classname";
-    public static final String SOLR_ENPOINT_PROPERTY_NAME = "solr.endpoint";
-    private static final String EMBEDDEDSERVERCLASS = "org.apache.solr.client.solrj.embedded.EmbeddedSolrServer";
-    private static final String HTTPSERVERCLASS = "org.apache.solr.client.solrj.impl.CommonsHttpSolrServer";
-
-	public static Log log = LogFactory.getLog(SolrServerFactory.class);
-	
-	private static CoreContainer coreContainer = null;
-	private static SolrServer solrServer = null;
-
-	public static SolrServer createSolrServer() throws Exception {
-		
-		String className = Settings.getConfiguration().getString(SOLR_SERVER_CLASSNAME_PROPERTY_NAME);
-		if (className != null && className.equals(EMBEDDEDSERVERCLASS)) {
-		    generateEmbeddedServer();
-		} else if (className != null && className.equals(HTTPSERVERCLASS)) {
-		    String solrServerUrl = Settings.getConfiguration().getString(SOLR_ENPOINT_PROPERTY_NAME);
-		    solrServer = new CommonsHttpSolrServer(solrServerUrl);
-		} else {
-		    throw new Exception("SolrServerFactory.createSolrServer - MetacatIndex doesn't support this solr server type: "+className);
-		}
-
-        
-        return solrServer;
-	}
-	
-	private static void generateEmbeddedServer() throws Exception {
-	    String solrHomeDir = Settings.getConfiguration().getString(SOLR_HOME_PROPERTY_NAME);
-        log.info("The configured solr home from properties is " + solrHomeDir);
-        String configFileName = Settings.getConfiguration().getString(SOLR_CONFIG_FILE_NAME_PROPERTY_NAME);
-        File configFile = new File(solrHomeDir, configFileName);
-        coreContainer = new CoreContainer(solrHomeDir, configFile);
-        coreContainer.load(solrHomeDir, configFile);
-        String collectioname = Settings.getConfiguration().getString(SOLR_COLLECTION_NAME_PROPERTY_NAME);
-        solrServer = new EmbeddedSolrServer(coreContainer, collectioname);
-	}
-	
-	public static CoreContainer getCoreContainer() {
-	    return coreContainer;
-	}
-}
\ No newline at end of file

Property changes on: metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/SolrServerFactory.java
___________________________________________________________________
Deleted: svn:eol-style
## -1 +0,0 ##
-native
\ No newline at end of property
Deleted: svn:keywords
## -1 +0,0 ##
-Author Date Id Revision
\ No newline at end of property