Index: metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/event/IndexEvent.java
===================================================================
--- metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/event/IndexEvent.java	(revision 7804)
+++ metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/event/IndexEvent.java	(revision 7805)
@@ -43,28 +43,11 @@
     private Date date = null;
     private Identifier pid = null;
     private String description = null;
-    private boolean isArchived = false;
-    private long serialNumber;
     
     
-    
-    /**
-     * Get the serial number of this event
-     * @return
-     */
-    public long getSerialNumber() {
-        return serialNumber;
-    }
+  
 
     /**
-     * Set the serial number for this event
-     * @param serialNumber
-     */
-    public void setSerialNumber(long serialNumber) {
-        this.serialNumber = serialNumber;
-    }
-
-    /**
      * Get the type of the event.
      * @return the type of the event
      */
@@ -128,19 +111,5 @@
         this.description = description;
     }
     
-    /**
-     * If the event has been archived.
-     * @return true if it has been archived; otherwise false.
-     */
-    public boolean isArchived() {
-        return isArchived;
-    }
-
-    /**
-     * Set the event to be archived
-     * @param isArchived
-     */
-    public void setArchived(boolean isArchived) {
-        this.isArchived = isArchived;
-    }
+   
 }
Index: metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/event/IndexEventFileLog.java
===================================================================
--- metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/event/IndexEventFileLog.java	(revision 7804)
+++ metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/event/IndexEventFileLog.java	(revision 7805)
@@ -122,24 +122,39 @@
      * @return
      * @throws IndexEventLogException
      */
-    public List<IndexEvent> getEvents(int type, Identifier pid, boolean archvied, Date start, Date end) throws IndexEventLogException {
+    public List<IndexEvent> getEvents(int type, Identifier pid, Date start, Date end) throws IndexEventLogException {
         List<IndexEvent> list = null;
         return list;
     }
     
+   
     /**
-     * Set the event with the specified serial number to be archived
-     * @param serialNumber
+     * Get the list of identifiers which were failed to build the solr index since the 
+     * previous timed indexing (including the ones in the timed indexing).
+     * @return the list of failure identifiers. The null will be returned if no failure. 
      */
-    public void setArchived(long serialNumber) throws IndexEventLogException {
-        
+    public List<Identifier> getFailedPids() throws IndexEventLogException {
+        return null;
     }
     
+    
     /**
-     * Set the all events with the specified identifier to be archived
-     * @param pid
+     * Get the latest SystemMetadata modification Date of the objects that were built
+     * the solr index during the previous timed indexing process.
+     * @return the date. The null will be returned if there is no such date.
+     * @throws IndexEventLogException
      */
-    public void setArchived(Identifier pid) throws IndexEventLogException {
+    public Date getLastProcessDate() throws IndexEventLogException {
+        return null;
+    }
+    
+    
+    /**
+     * Set the SystemMetadata modification Date of the objects that were built
+     * the solr index during the previous timed indexing process.
+     * @throws IndexEventLogException
+     */
+    public void setLastProcessDate(Date date) throws IndexEventLogException {
         
     }
 }
Index: metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/event/IndexEventLog.java
===================================================================
--- metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/event/IndexEventLog.java	(revision 7804)
+++ metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/event/IndexEventLog.java	(revision 7805)
@@ -51,17 +51,30 @@
      * @return
      * @throws IndexEventLogException
      */
-    public List<IndexEvent> getEvents(int type, Identifier pid, boolean archvied, Date start, Date end) throws IndexEventLogException;
+    public List<IndexEvent> getEvents(int type, Identifier pid, Date start, Date end) throws IndexEventLogException;
     
     /**
-     * Set the event with the specified serial number to be archived
-     * @param serialNumber
+     * Get the list of identifiers which were failed to build the solr index since the 
+     * previous timed indexing (including the ones in the timed indexing).
+     * @return the list of failure identifiers. The null will be returned if no failure. 
      */
-    public void setArchived(long serialNumber) throws IndexEventLogException;
+    public List<Identifier> getFailedPids() throws IndexEventLogException;
     
+    
     /**
-     * Set the all events with the specified identifier to be archived
-     * @param pid
+     * Get the latest SystemMetadata modification Date of the objects that were built
+     * the solr index during the previous timed indexing process.
+     * @return the date. The null will be returned if there is no such date.
+     * @throws IndexEventLogException
      */
-    public void setArchived(Identifier pid) throws IndexEventLogException;
+    public Date getLastProcessDate() throws IndexEventLogException;
+    
+    
+    /**
+     * Set the SystemMetadata modification Date of the objects that were built
+     * the solr index during the previous timed indexing process.
+     * @throws IndexEventLogException
+     */
+    public void setLastProcessDate(Date date) throws IndexEventLogException;
+ 
 }
Index: metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/SolrIndex.java
===================================================================
--- metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/SolrIndex.java	(revision 7804)
+++ metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/SolrIndex.java	(revision 7805)
@@ -401,13 +401,13 @@
                 try {
                     UpdateResponse response = solrServer.add(solrDoc);
                     solrServer.commit();
-                    event.setType(IndexEvent.SUCCESSINSERT);
+                    /*event.setType(IndexEvent.SUCCESSINSERT);
                     event.setDescription("Successfully insert the solr index for the id "+pid.getValue());
                     try {
                         EventlogFactory.createIndexEventLog().write(event);
                     } catch (Exception e) {
                         log.error("SolrIndex.insertToIndex - IndexEventLog can't log the index inserting event :"+e.getMessage());
-                    }
+                    }*/
                 } catch (SolrServerException e) {
                     event.setType(IndexEvent.FAILUREINSERT);
                     event.setDescription("Failed to insert the solr index for the id "+pid.getValue()+" since "+e.getMessage());
@@ -632,13 +632,13 @@
             try {
                 solrServer.deleteById(pid);
                 solrServer.commit();
-                event.setType(IndexEvent.SUCCESSDELETE);
+                /*event.setType(IndexEvent.SUCCESSDELETE);
                 event.setDescription("Successfully remove the solr index for the id "+identifier.getValue());
                 try {
                     EventlogFactory.createIndexEventLog().write(event);
                 } catch (Exception e) {
                     log.error("SolrIndex.removeFromIndex - IndexEventLog can't log the index deleting event :"+e.getMessage());
-                }
+                }*/
             } catch (SolrServerException e) {
                 event.setType(IndexEvent.FAILUREDELETE);
                 event.setDescription("Failurely remove the solr index for the id "+identifier.getValue()+" since "+e.getMessage());
Index: metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/IndexGenerator.java
===================================================================
--- metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/IndexGenerator.java	(revision 7804)
+++ metacat-index/src/main/java/edu/ucsb/nceas/metacat/index/IndexGenerator.java	(revision 7805)
@@ -220,7 +220,7 @@
     }
     
     public void run() {
-        IndexEvent event = new IndexEvent();
+        /*IndexEvent event = new IndexEvent();
         event.setDate(Calendar.getInstance().getTime());
         event.setType(IndexEvent.STARTTIMEDINDEX);
         event.setDescription("Start the timed index job");
@@ -228,7 +228,7 @@
             EventlogFactory.createIndexEventLog().write(event);
         } catch (Exception e) {
             log.error("IndexGenerator.run - IndexEventLog can't log the timed indexing start event :"+e.getMessage());
-        }
+        }*/
         try {
             
             indexAll();
@@ -258,7 +258,7 @@
         } catch (FileNotFoundException e) {
             log.error("IndexGenerator.run - Metadata-Index couldn't generate indexes for those documents which haven't been indexed : "+e.getMessage());
         }
-        event.setDate(Calendar.getInstance().getTime());
+        /*event.setDate(Calendar.getInstance().getTime());
         event.setType(IndexEvent.FINISHTIMEDINDEX);
         event.setDescription("Finish the timed index job");
         try {
@@ -265,7 +265,7 @@
             EventlogFactory.createIndexEventLog().write(event);
         } catch (Exception e) {
             log.error("IndexGenerator.run - IndexEventLog can't log the timed indexing finish event :"+e.getMessage());
-        }
+        }*/
     }
     
     /*